Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# ColorTable Class Reference

Base class of ColorTable64 and ColorTableTSL. More...

`#include <ColorTable.h>`

Inheritance diagram for ColorTable:

[legend]
List of all members.

## Public Member Functions
| ColorTable ()
| Constructor.
| ~ColorTable ()
| Destructor.
virtual colorClass | getColorClass (const unsigned char y, const unsigned char u, const unsigned char v) const
| Calculates the color class of a pixel.
virtual void | generateColorClassImage (const Image &image, ColorClassImage &colorClassImage) const
| Segments an image to an color class image.
virtual void | generateHighResColorClassImage (const Image &image, ColorClassImage &colorClassImage) const
| Segments an image to an color class image using the high resolution y values.
virtual void | clear ()
| Sets the color class of every 4x4x4 to noColor.
virtual void | clearChannel (colorClass colorClass)
| Sets all cubes that have the given color class to noColor.
virtual void | addColorClass (colorClass colorClass, unsigned char y, unsigned char u, unsigned char v, unsigned char range)
| Sets the color class for a cube with the size "range" around a pixel given by y,u,v to the given color class.
virtual void | shrink ()
| This function marks the outer pixels of all segmented colors in the colorspace as noColor.
virtual void | shrink (unsigned char color)
| This function marks the outer pixels of the parameter color in the colorspace as noColor.
virtual void | grow ()
| This function marks all noColor pixels in the colorspace, which are neighbors of segmented pixels, with the neighboring color.
virtual void | grow (unsigned char color)
| This function marks all noColor pixels in the colorspace, which are neighbors of the parameter color, with the neighboring color.

## Detailed Description

Base class of ColorTable64 and ColorTableTSL.

Definition at line 23 of file ColorTable.h.

## Constructor & Destructor Documentation

ColorTable::ColorTable | ( |  | ) | `[inline]`

| Constructor. Definition at line 27 of file ColorTable.h.

ColorTable::~ColorTable | ( |  | ) | `[inline]`

| Destructor. Definition at line 30 of file ColorTable.h.

## Member Function Documentation

virtual colorClass ColorTable::getColorClass | ( | const unsigned char | y,
|  | const unsigned char | u,
|  | const unsigned char | v
| ) | const`[inline, virtual]`

  | Calculates the color class of a pixel. Parameters:
  y | the y value of the pixel
  u | the u value of the pixel
  v | the v value of the pixel
Returns: the color class Reimplemented in ColorTable32K, ColorTable64, ColorTableTSL, ColorTableCuboids, and ColorTableReferenceColor. Definition at line 39 of file ColorTable.h. References noColor. Referenced by ChallengeSpecialVision::countPixels(), Image::getClassifiedColor(), and GT2004EdgeDetection::getColor().

virtual void ColorTable::generateColorClassImage | ( | const Image & | image,
|  | ColorClassImage & | colorClassImage
| ) | const`[inline, virtual]`

  | Segments an image to an color class image. This doesn't need to used in the image processor, but is needed for visualisation of color tables. Parameters:
  image | A reference to the image to be segmented
  colorClassImage | A reference to the color class image to be created
Returns: A reference to the created color class image. Reimplemented in ColorTable32K, ColorTable64, ColorTableTSL, ColorTableCuboids, and ColorTableReferenceColor. Definition at line 53 of file ColorTable.h. Referenced by BarCodeReader::execute(), and SlamImageProcessor::execute().

virtual void ColorTable::generateHighResColorClassImage | ( | const Image & | image,
|  | ColorClassImage & | colorClassImage
| ) | const`[inline, virtual]`

  | Segments an image to an color class image using the high resolution y values. This doesn't need to used in the image processor, but is needed for visualisation of color tables. Parameters:
  image | A reference to the image to be segmented
  colorClassImage | A reference to the color class image to be created
Returns: A reference to the created color class image. Reimplemented in ColorTable32K, and ColorTable64. Definition at line 67 of file ColorTable.h.

virtual void ColorTable::clear | ( |  | ) | `[inline, virtual]`

| Sets the color class of every 4x4x4 to noColor. Reimplemented in ColorTable32K, ColorTable64, ColorTableTSL, ColorTableCuboids, and ColorTableReferenceColor. Definition at line 73 of file ColorTable.h.

virtual void ColorTable::clearChannel | ( | colorClass | colorClass | ) | `[inline, virtual]`

| Sets all cubes that have the given color class to noColor. Reimplemented in ColorTable32K, and ColorTable64. Definition at line 76 of file ColorTable.h.

virtual void ColorTable::addColorClass | ( | colorClass | colorClass,
|  | unsigned char | y,
|  | unsigned char | u,
|  | unsigned char | v,
|  | unsigned char | range
| ) | `[inline, virtual]`

| Sets the color class for a cube with the size "range" around a pixel given by y,u,v to the given color class. Reimplemented in ColorTable32K, and ColorTable64. Definition at line 82 of file ColorTable.h.

virtual void ColorTable::shrink | ( |  | ) | `[inline, virtual]`

| This function marks the outer pixels of all segmented colors in the colorspace as noColor. Reimplemented in ColorTable64. Definition at line 92 of file ColorTable.h.

virtual void ColorTable::shrink | ( | unsigned char | color | ) | `[inline, virtual]`

| This function marks the outer pixels of the parameter color in the colorspace as noColor. &param color The color to shrink Reimplemented in ColorTable64. Definition at line 98 of file ColorTable.h.

virtual void ColorTable::grow | ( |  | ) | `[inline, virtual]`

| This function marks all noColor pixels in the colorspace, which are neighbors of segmented pixels, with the neighboring color. Reimplemented in ColorTable64. Definition at line 104 of file ColorTable.h.

virtual void ColorTable::grow | ( | unsigned char | color | ) | `[inline, virtual]`

| This function marks all noColor pixels in the colorspace, which are neighbors of the parameter color, with the neighboring color. Reimplemented in ColorTable64. Definition at line 110 of file ColorTable.h.

The documentation for this class was generated from the following file:

- Representations/Perception/ColorTable.h